c $Header: /home/evian/ROOTCVS/ORCA/OPA/SRC_UCL/defgrid.f,v 1.1.1.1 2001/06/05 11:56:54 valcke Exp $
      subroutine defgrid(nflag,E1T,E2T,E1V,E2U,GPHIT,TMASK)
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c mise en place des masques et autres tableaux lie a la grille.
c cas nflag=2 : impression de controle sur fichier "mouchard" ;
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c Cice [Cic0] => ligne specifique a la version avec [sans] glace marine .
c Cfcc [Cfc0] => option : Avec Coeff Coriolis Reciproque = -2.Omega.cos(phi)
c-----
c  modif : 01/05/99
 
      include 'type.com'
      include 'const.com'
      include 'para.com'
      include 'bloc.com'
      include 'ice.com'
      include 'reper.com'
      include 'dynami.com'
 
c dx1       Relative length of a grid square (direction x). Gen. in radian
c dx2       Relative length of a grid square (direction y). Gen. in radian
c h1        Metric coefficient in the direction x (defined at the center
c           of the grid )
c h2        Metric coefficient in the direction y (defined at the center
c           of the grid )
c d2d1      Derivatite of h2 in the x direction (defined at the center)
c d1d2      Derivatite of h1 in the y direction (defined at the center)
c h1p       Idem h1 for the bottom left corner of the grid
c h2p       Idem h2 for the bottom left corner of the grid
c d2d1p     Idem d2d1 for the bottom left corner of the grid
c d1d2p     Idem d1d2 for the bottom left corner of the grid
c h1pp      Idem h1 for the middle up of the grid
c h2pp      Idem h2 for the middle up of the grid
c
c--variables locales :
      dimension zbath(kmax), dzbath(kmax)
      dimension hs(imax,jmax), unszw(kmax)
      dimension csxsa(jmax), csxua(jmax)
C     dimension snxua(jmax)
      dimension zrr(5),zd1(5),zd2(5)
      dimension tauco(20)
      dimension ipt0v(10), jpt0v(10)
 
      dimension dx1(imax,jmax),dx2(imax,jmax),
     &          h1(imax,jmax),h2(imax,jmax),
     &          h1p(imax,jmax),h2p(imax,jmax),
     &          d1d2p(imax,jmax),d2d1p(imax,jmax),
     &          d1d2(imax,jmax),d2d1(imax,jmax)
     &         ,h1pp(imax,jmax),h2pp(imax,jmax)
      dimension E1T(imax,jmax),E2T(imax,jmax),E1V(imax,jmax)
      dimension E2U(imax,jmax),GPHIT(imax,jmax),TMASK(imax,jmax)
 
      character*1  cc1(0:9)
      character*8  fmt1
      character*30 fmt, fmtrep
 
      fotr(rf,d1f,d2f,h) = rf*exp(-h/d1f)+(1.0-rf)*exp(-h/d2f)
      data tauco  /6.6,6.6,7.0,7.2,7.1,6.8,6.5,6.6,7.1,7.6,
     &             6.6,6.1,5.6,5.5,5.8,5.8,5.6,5.6,5.6,5.6/
C    &             6.6,6.1,5.6,5.5,5.8,6.1,6.2,6.0,5.6,5.6/
 
      kmaxp1 = kmax + 1
c      write(6,*)E1T(10,10),E2T(10,10),
c     &         E1V(10,10),E2U(10,10),GPHIT(10,10),TMASK(10,10)
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  1 ) Initialisation des variables locales et globales (common) .     |
c-----------------------------------------------------------------------
      jeq=jmax/2
      do 1 n=1,9
        cc1(n) = '-'
 1    continue
      cc1(0) = '|'
      cc1(5) = '5'
 
      do 11 j=1,jmax
       is1(j) = imax
       is2(j) = 1
       iu1(j) = imax
       iu2(j) = 1
       iuf1(j) = imax
       iuf2(j) = 1
       isf1(j) = imax
       isf2(j) = 1
 11   continue
 
      do 12 k=1,kmax
        z(k)  = 0.0
        zw(k) = 0.0
        dz(k)  = 0.0
        dzw(k) = 0.0
        unsdz(k)  = 0.0
        unsdzw(k) = 0.0
 12   continue
      z(kmax+1) = 0.0
      zw(kmax+1) = 0.0
      dzw(kmax+1) = 0.0
      unsdzw(kmax+1) = 0.0
 
      do 20 j=1,jmax
       do 20 i=1,imax
        hs(i,j) = 0.0
        huy(i,j) = 0.0
        hux(i,j) = 0.0
        hu(i,j) = 0.0
        unshu(i,j) = 0.0
C       kfs(i,j) = kmax
C       kfu(i,j) = kmax
        kniv(i,j,-1) = kmaxp1
        kniv(i,j, 0) = kmaxp1
        kniv(i,j, 1) = kmaxp1
        phifu(i,j)  = 0.0
        phifv(i,j)  = 0.0
        phisc(i,j)  = 0.0
 20   continue
 
      do 21 ns=0,nsmax
       do 21 j=1,jmax
        do 21 i=1,imax
         fss(i,j,ns)  = 0.0
         phifs(i,j,ns)  = 0.0
         phiss(i,j,ns)  = 0.0
         rappes(i,j,ns) = 0.0
         phimnx(i,j,0,ns) = cstmin
         phimnx(i,j,1,ns) = cstmax
 21   continue
 
      do 22 nn=1,6
       do 22 j=1,jmax
        do 22 i=1,imax
         phihhh(i,j,nn) = 0.0
 22   continue
 
      do 30 k=1,kmax
       do 30 j=1,jmax
        do 30 i=1,imax
         fub(i,j,k) = 0.0
         fvb(i,j,k) = 0.0
         q(i,j,k) = 0.0
         bvf(i,j,k) = 0.0
         avsdz(i,j,k) = 0.0
         avudz(i,j,k) = 0.0
         fqajc(i,j,k) = 0.0
         tms(i,j,k) = 0.0
         tmu(i,j,k) = 0.0
         rappel(i,j,k) = 0.0
 30   continue
 
      do 31 k=1,kmax+1
       do 31 j=1,jmax
        do 31 i=1,imax
         w(i,j,k) = 0.0
         phizzz(i,j,k,1) = 0.0
         phizzz(i,j,k,2) = 0.0
 31   continue
 
c--Initialisation des champs scalaires et des forcings, de l'energie
c  cinetique turbulente
      do 32 ns=1,nsmax
       do 32 k=1,kmax
	nrap(k,ns) = 0
        do 32 j=1,jmax
         do 32 i=1,imax
          scalr(i,j,k,ns)=0.0
          scal(i,j,k,ns) = scal0(k,ns)
          phivs(i,j,k,ns) = 0.0
 32   continue
 
      do 33 k=1,kmax
       do 33 j=1,jmax
        do 33 i=1,imax
         q2turb(i,j,k)=q2tmin
 33   continue
 
c--Initialisation des scalaires associes au flux d'eau douce
      do 34 ns=1,nsmax
       do 34 j=1,jmax
        do 34 i=1,imax
         scs(i,j,ns) = scpme(ns)
 34   continue
 
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  2 ) Mise en place des Constantes ( resolution, grille ...)          |
c-----------------------------------------------------------------------
 
c--taille (maximale) du bassin (pts type scalaire) :
      ims1 = 2
      ims2 = imax - 1
      js1 = 2
      js2 = jmax - 1
      ks1 = 1
      ks2 = kmax
c--autres :
      ku2 = ks2
      ku1 = ks1
 
c--constantes liees a la resolution / au repere / a la Geographie :
C     call geogra(js1, js2, jeq, jdl1, jdl2, ijsdl, ijudl,
C    &            iberp, ibera)
 
      if (ltest.lt.1) then
c--bassin type rectangulaire :
        jcl1 = js2
        jcl2 = js1
      else
c--bassin avec condition cyclique, definition des secteurs a raccorder :
        jcl1 = js1
        jcl2 = jeq
      endif
 
c--mise en place des constantes
      jberpm = 1
      iberpm = 1
      jberam = 1
      iberam = 1
c--initialisation de npo1i0
      npo1i0=0
 
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  3 ) Pour chaque grille, mise en place des tableaux geometriques .   |
c-----------------------------------------------------------------------
 
c-------------------
c Conventions :    |
c-------------------
c  indices 1 \ 2 <-> localisation dans les 2 direction x \ y
c    3eme indice <-> localisation sur la maille :
c  0=Centre, 1=Bord W x(i-1/2), 2=bord S y(j-1/2), 3=coin SW x(i-1/2),y(j-1/2)
c-------------------
c Coeficients metriques : cmx \ cmy = coef. metriq. direction x (h1) \ y (h2)
c Derives des coef. metriq. : cmxdy \ cmydx = d(cmx)/dy  \ d(cmy)/dx localis.3
c
c Autres coeficients construits a partir des coef. metriq. :
c  cmxy(i,j,0\3) = cmx(i,j,0\3) * cmy(i,j,0\3) = element de surface
c  cmxy(i,j,1\2) = cmx(i,j,1\2) / cmy(i,j,1\2)
c  smx = 1 / cmx ; smy = 1 / cmy ; smxy = 1 / cmxy
c-------------------
c conventions locales :
c  cs <- cosinus ; sc <- 1 / cosinus ; sn <- sinus [ou 1er lettre doublee]
c  x\y_s\u_w\a : relatif a
c   longitude (x) \ latitude (y) <-- different de la convention coef. metriqu.
c   d'un point scalaire (=Centre) (s) \ vitesse (Coin) (u) [par defaut = s]
c   sur la grille WW (w) \ AA (a)
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
 
c--3.1 coeficients metriques
c-----------------------------------------------------------
 
c--mise en place des tableaux geometriques cos,sin, etc ...
      do 320 j=1,jmax
 
c--metrique : grille spherique long x lat :
        do 310 i=1,imax
c- coef :
c- metric coefficients for sea ice dynamic:
 
Cold      dx1(i,j)   = dlong*radian
Cold      yu2rad     = (ysdeg + 0.5*dlat)*radian
Cold      dx2(i,j)   = sin(yu2rad) -sin(yurad)
Cold      h1(i,j)    = rterre*ccsysw
Cold      h2(i,j)    = rterre/ccsysw
Cold      d1d2(i,j)  = -rterre*sin(ysdeg*radian)*sscysw
Cold      d2d1(i,j)  = 0.0
	  jm1=max(1,j-1)
	  im1=(i-1)+(imax-2)*(1/i)
          dx1(i,j)   = 1.0
          dx2(i,j)   = 1.0
          h1(i,j)    = E1T(i,j)
          h2(i,j)    = E2T(i,j)
          d1d2(i,j)  = E1V(i,j)-E1V(i,jm1)
          d2d1(i,j)  = E2U(i,j)-E2U(im1,j)
c--facteur de Corriolis :
          fs2cor(i,j) = omega * sin(GPHIT(i,j)*radian)
c- Sinus(Lat.Geographique) :
          covrai(i,j) = sin(GPHIT(i,j)*radian)
c	  write(95,*) i,j,GPHIT(i,j)
 310    continue
 320  continue
 
 
C     do 351 i=1,imax
C      do 351 j=1,jmax
C        write(91,*) covrai(i,j),i,j
C351  continue
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  4 ) Computation of metric coefficients needed in ice dynamics       |
c-----------------------------------------------------------------------
c
c
c--4.1. WEIGHTS FOR COMPUTING INTERPOLATED VALUES AT THE CORNERS
c       OF THE GRID SQUARES.
c----------------------------------------------------------------
c
      do 420 j=2,jmax
        jm1 = j-1
        do 410 i=1,imax
          im1           = (i-1)+(imax-2)*(1/i)
          usden         = 1.0/((h1(i,j)+h1(im1,j))
     &                    *(h2(i,j)+h2(i,jm1)))
          wght(i,j,1,1) = usden*h1(i,j)*h2(i,j)
          wght(i,j,1,2) = usden*h1(i,j)*h2(i,jm1)
          wght(i,j,2,2) = usden*h1(im1,j)*h2(i,jm1)
          wght(i,j,2,1) = usden*h1(im1,j)*h2(i,j)
 410    continue
 420  continue
c
c--4.2. metric coefficients at the grid squares corners,
c       and mid-sides points, and their derivatives (h1p,  h2p,
c       h1pp, h2pp, d1d2p,d2d1p), corilis coefficient (zfn)
c       and coefficients for the strain rate tensor (akappa).
c----------------------------------------------------------------
c
      do 430 i=1,imax
        h1p(i,1)   = 0.0
        h2p(i,1)   = 1.0e+20
        d1d2p(i,1) = 1.0e+20
        d2d1p(i,1) = 0.0
c
        zfn(i,1)   = fs2cor(i,1)*2
 430  continue
c
      do 450 j=1,jmax-1
        do 440 i=1,imax
          im1          = (i-1)+(imax-2)*(1/i)
          ip1          = (i+1)-(imax-2)*(i/imax)
          h1p(i,j+1)   = h1(i,j+1)*wght(i,j+1,2,2)+
     &                   h1(im1,j+1)*wght(i,j+1,1,2)+
     &                   h1(i,j)*wght(i,j+1,2,1)+
     &                   h1(im1,j)*wght(i,j+1,1,1)
          h2p(i,j+1)   = h2(i,j+1)*wght(i,j+1,2,2)+
     &                   h2(im1,j+1)*wght(i,j+1,1,2)+
     &                   h2(i,j)*wght(i,j+1,2,1)+
     &                   h2(im1,j)*wght(i,j+1,1,1)
          d1d2p(i,j+1) = 2.0*
     &                   (dx1(i,j)*(-h1(im1,j)+h1(im1,j+1))+
     &                    dx1(im1,j)*(-h1(i,j)+h1(i,j+1)))/
     &                   ((dx1(i,j)+dx1(im1,j))*(dx2(i,j)+dx2(i,j+1)))
          d2d1p(i,j+1) = 2.0*
     &                   (dx2(i,j+1)*(h2(i,j)-h2(im1,j))+
     &                    dx2(i,j)*(h2(i,j+1)-h2(im1,j+1)))/
     &                   ((dx1(i,j)+dx1(im1,j))*(dx2(i,j)+dx2(i,j+1)))
c
          h1pp(i,j)    = (dx2(i,j)*h1(i,j+1)+dx2(i,j+1)*h1(i,j))/
     &                   (dx2(i,j)+dx2(i,j+1))
c
          zfn(i,j+1)   = 2*fs2cor(i,j+1)
 440    continue
 450  CONTINUE
      do j=1,jmax
        do i=1,imax
          ip1          = (i+1)-(imax-2)*(i/imax)
          h2pp(i,j)    = (dx1(i,j)*h2(ip1,j)+dx1(ip1,j)*h2(i,j))/
     &        (dx1(i,j)+dx1(ip1,j))
        END DO 
      END DO 
C
      do 460 i=1,imax
        h1pp(i,jmax) = 0.0
 460  continue
c
      do 475 j=1,jmax
        do 470 i=1,imax
          ip1             = (i+1)-(imax-2)*(i/imax)
          akappa(i,j,1,1) = 1.0/(2.0*h1(i,j)*dx1(i,j))
          akappa(i,j,1,2) = d1d2(i,j)/(4.0*h1(i,j)*h2(i,j))
          akappa(i,j,2,1) = d2d1(i,j)/(4.0*h1(i,j)*h2(i,j))
          akappa(i,j,2,2) =  1.0/(2.0*h2(i,j)*dx2(i,j))
 470    continue
 475  continue
c
c--4.3. COEFFICIENTS FOR DIVERGENCE OF THE STRESS TENSOR.
c---------------------------------------------------------
c
      do 485 j=2,jmax
        jm1 = j-1
        do 480 i=1,imax
          im1=(i-1)+imax*(1/i)
          usden               =
     &           1.0/(h1p(i,j)*h2p(i,j)*(dx1(i,j)+dx1(im1,j))
     &           *(dx2(i,j)+dx2(i,jm1)))
          alambd(i,j,2,2,2,1) = usden*2.0*dx2(i,j)*h2(i,jm1)
          alambd(i,j,2,2,2,2) = usden*2.0*dx2(i,jm1)*h2(i,j)
          alambd(i,j,2,2,1,1) = usden*2.0*dx2(i,j)*h2(im1,jm1)
          alambd(i,j,2,2,1,2) = usden*2.0*dx2(i,jm1)*h2(im1,j)
          alambd(i,j,1,1,2,1) = usden*2.0*dx1(im1,j)*h1(i,jm1)
          alambd(i,j,1,1,1,1) = usden*2.0*dx1(i,j)*h1(im1,jm1)
          alambd(i,j,1,1,2,2) = usden*2.0*dx1(im1,j)*h1(i,j)
          alambd(i,j,1,1,1,2) = usden*2.0*dx1(i,j)*h1(im1,j)
          alambd(i,j,1,2,1,1) = usden*d1d2p(i,j)*dx2(i,j)*dx1(i,j)
          alambd(i,j,1,2,2,1) = usden*d1d2p(i,j)*dx2(i,j)*dx1(im1,j)
          alambd(i,j,1,2,1,2) = usden*d1d2p(i,j)*dx2(i,jm1)*dx1(i,j)
          alambd(i,j,1,2,2,2) = usden*d1d2p(i,j)*dx2(i,jm1)*dx1(im1,j)
          alambd(i,j,2,1,1,1) = usden*d2d1p(i,j)*dx2(i,j)*dx1(i,j)
          alambd(i,j,2,1,2,1) = usden*d2d1p(i,j)*dx2(i,j)*dx1(im1,j)
          alambd(i,j,2,1,1,2) = usden*d2d1p(i,j)*dx2(i,jm1)*dx1(i,j)
          alambd(i,j,2,1,2,2) = usden*d2d1p(i,j)*dx2(i,jm1)*dx1(im1,j)
 480    continue
 485  continue
c
c--4.4 METRICS FOR ADVECTION AND SCALAR DIFFUSION COEFFICIENTS.
c--------------------------------------------------------------
c
c  dxs1, dxs2: LENGHT OF THE GRID SQUARES SIDES.
c  dxc1, dxc2: LENGHT OF THE GRID SQUARES CENTRES.
c  area: SURFACE OF A GRID SQUARE.
c
      do 495 j=1,jmax
        do 490 i=1,imax
          dxs1(i,j)  = h1pp(i,j)*dx1(i,j)
          dxs2(i,j)  = h2pp(i,j)*dx2(i,j)
          dxc1(i,j)  = h1(i,j)*dx1(i,j)
          dxc2(i,j)  = h2(i,j)*dx2(i,j)
          area(i,j)  = dxc1(i,j)*dxc2(i,j)
 490    continue
 495  continue
c
      do 497 j=2,jmax
       do 497 i=1,imax
         im1=(i-1)+(imax-2)*(1/i)
         bkappa(i,j,1,1) = dxs2(i,j)/area(i,j)
         bkappa(i,j,1,2) = dxs2(im1,j)/area(i,j)
         bkappa(i,j,2,2) = dxs1(i,j)/area(i,j)
         bkappa(i,j,2,1) = dxs1(i,j-1)/area(i,j)
 497  continue
c
      do 498 i=1,imax
         j=1
         bkappa(i,j,1,1) = dxs2(i,j)/area(i,j)
         bkappa(i,j,1,2) = dxs2(im1,j)/area(i,j)
         bkappa(i,j,2,2) = dxs1(i,j)/area(i,j)
         bkappa(i,j,2,1) = dxs1(i,1)/area(i,j)
 498  continue
c
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  5 ) Definition du domaine : Lecture de la bathymetrie               |
c-----------------------------------------------------------------------
 
c--mise en place des echelles de profondeurs :
      zw(ks2+1) = 10.0
      do 510 k=ks2,ks1,-1
        z(k)  = -5.0
        dz(k) = 10
        zw(k)    = -10
        unsdz(k) = 1.0 / dz(k)
        if (zw(k).ne.zero) unszw(k) = 1.0 / zw(k)
 510  continue
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
 
      do 520 k=ks1+1,ks2
        dzw(k) = z(k)  - z(k-1)
        unsdzw(k) = 1.0 / dzw(k)
 520  continue
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  6 ) Mise en place des masques & indices de debut/fin de domaine .   |
c-----------------------------------------------------------------------
 
c--6.1 Centre des mailles (pt. type scalaire) - masque Terre/Mer pts Scal. :
c---------------------------------------------------------------------------
 
c- calcul des profondeurs et calcul des indices de debut et fin de bassin :
      ju1 = 2
      ju2 = jmax-1
      do 615 j=1,jmax
       is1(j) = 2
       is2(j) = imax-1
       iu1(j) = 2
       iu2(j) = imax-1
       do 615 i=1,imax
           do 610 k=ks1,ks2
             tms(i,j,k) = TMASK(i,j)
	     kfs(i,j)=int(tms(i,j,k))
 610       continue
 615  continue
c      do 620 j=2,jmax
c        do 620 i=2,imax-1
c          tmu(i,j,ks2)=tms(i,j,k)*tms(i-1,j,k)
c     &               *tms(i,j-1,k)*tms(i-1,j-1,k)
c 620  continue
      do 620 j=2,jmax
        do 620 i=2,imax-1
          tmu(i,j,ks2)=tms(i,j,ks2)*tms(i-1,j,ks2)
     &        *tms(i,j-1,ks2)*tms(i-1,j-1,ks2)
          
 620  continue
      do i=1,imax
        tmu(i,1,ks2)= 0.0
      END DO
      CALL lbcice(tmu(:,:,ks2),4,1,1,1)
 
c--fin du calcul du volume.
      airtot=0.0
      do 790 j=1,jmax
         do 790 i=1,imax
C           aire(i,j) = ctmi(i,j,ks2,0)*dx*dy/1.0d+12
            aire(i,j) = h1(i,j)*h2(i,j)*tms(i,j,ks2)
	    airtot=airtot+aire(i,j)
790   continue
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  8 ) Ecriture de controle - parametres et indices du domaine .       |
c-----------------------------------------------------------------------
 
      if(nflag.ne.2) goto 899
c--ecriture de controle :
      write(99,*) 'dtb, dtu, dts(k) :'
C     WRITe(99,*)  dts
      write(99,*) 'dx, dy, pi :'
      write(99,*)  pi
      write(99,*) 'icheck, jcheck, kcheck :'
      write(99,*)  icheck, jcheck, kcheck
 
      write(99,*) 'zw :'
C     write(99,*)  zw
      write(99,*) 'dzw :'
C     write(99,*)  dzw
 
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      write(99,*) 'jeq, ijsdl, ijudl :'
      write(99,*)  jeq,ijsdl,ijudl
c-----
      write(99,*)
c-----
      write(99,*) 'bering :', bering
      write(99,*) 'iberp, jberp, ibera, jbera :'
      write(99,*)  iberp, jberp, ibera, jbera
      write(99,*) 'ju1, ju2, imu1, imu2 :'
      write(99,*)  ju1, ju2, imu1, imu2
      write(99,'(A)') 'Indices Debut(=1)/Fin(=2) :'
      write(99,*) ' j | is1,is2   iu1,iu2  iuf1,iuf2'
     &          //' isf1,isf2     (iszon,iezon)(0/1/2/3) :'
      do 893 j=jmax,1,-1
        write(99,'(I3,1X,A1,4(2I4,2X),3(2I4,1X),2I4)') j, '|'
     &   , is1(j),  is2(j),  iu1(j),  iu2(j)
     &   , iuf1(j), iuf2(j), isf1(j), isf2(j)
     &   , (iszon(j,n),iezon(j,n),n=0,nbsmax)
 893  continue
 
c-- ecriture du tableau kbath reconstruit (=somme[tm(k)]) :
c      <-- transfere dans  la routine "local"
 
      write(99,*) 'tableau kfs(i,j) :'
      if (kmax.le.15) then
        nfrc = 125
        fmt1 = 'Z1'
      else
        nfrc = 41
        fmt1 = 'I3'
      endif
      write(fmtrep,'(A,I3,A)') '(',iabs(nfrc),'A1)'
      do 894 ii1=1,imax,nfrc
       ii2=min(ii1+nfrc-1,imax)
       write(fmt,'(A,I3,2A)') '(',(ii2-ii1+1),fmt1,',A1,I3)'
       write(99,*) 'portion de i=',ii1,' a i=',ii2
       write(99,fmtrep) (cc1(mod(i,10)),i=ii1,ii2)
       do 894 j=jmax,1,-1
       write(99,fmt) (kfs(i,j),i=ii1,ii2),'|',j
 894  continue
      write(99,*)  'area',airtot
 
 899  continue
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  9 ) Needed in ice dynamic (comprise tms).                           |
c-----------------------------------------------------------------------
c
c--9.1. Ice thickness and advection masks.
c-------------------------------------------
c
      do 905 j=1,jmax
        do 905 i=1,imax
          zindfa(i,j) = tms(i,j,ks2)
 905  continue
 
c  Diffusion coefficients.
c
       ah = (uvdif/ren)*gridsz
       do 920 j=1,jmax-1
        jp1 = (j+1)
        do 910 i=1,imax
          ip1       = (i+1)-(imax-2)*(i/imax)
          dfhu(i,j) = tms(i,j,ks2)*tms(ip1,j,ks2)*ah
          dfhv(i,j) = tms(i,j,ks2)*tms(i,jp1,ks2)*ah
 910    continue
 920   continue
c     write (89,*) ah
c     write (89,*) dfhv
c
c--9.2. Determine cloud optical depths as a function of
c       latitude (CHOU ET AL., 1981).
c------------------------------------------------------
c
      do 930 j=js1,js2
         do 930 i=is1(j),is2(j)
         alat    = asin(covrai(i,j))/radian
         clat    = (95.0-alat)/10.0
         indx    = 1+int(clat)
         indxp1  = indx+1
         dl      = clat-int(clat)
         dr      = 1.0-dl
         tauc(i,j) = dr*tauco(indx)+dl*tauco(indxp1)
 930    continue
Cic0  return
 
      return
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c 11 ) Traitement des cas pathologiques .                              |
c-----------------------------------------------------------------------
 
 1710 continue
      write(6,'(A,2I5)') 'Stop in routine "defgrid" :'
     &    //' ncomax too small ! (k,ncomax)= ', k, ncomax
      stop
 
 1730 continue
      write(6,'(A,4I5)') 'Stop in routine "defgrid" :'
     &    //' nlpmax too small ! (i,j,k,nlpmax)= ', i,j,k, ncomax
      stop
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c- fin de la routine defgrid -
      end
