c $Header: /home/evian/ROOTCVS/ORCA/OPA/SRC_UCL/icetooce.f,v 1.1.1.1 2001/06/05 11:56:54 valcke Exp $
      subroutine icetooce(sbcocn)
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c this routine transfers the information from the ice to the ocean
c  modif : 10/9/99
 
      include 'type.com'
      include 'const.com'
      include 'para.com'
      include 'bloc.com'
      include 'ice.com'
      include 'dynami.com'

c--Local variables
      real sbcocn(imax,jmax,11)
      real zepsi
C
c--transmit forcing
      wtocal=1./(4.18*1.E4)
      dttofl=-1.*rho0*cpo/(dts(ks2)*unsdz(ks2))
      dstofl=-1.*rho0/(dts(ks2)*unsdz(ks2))
      netody=-1.*rho0/0.1
      zepsi=1.E-16
C
      sbcocn(:,:,3: 6) = 0.0e0
      sbcocn(:,:,8:11) = 0.0e0
c!!!!!!!!!!!!!!SIGN CONVENTION!!!!!!!!!!!!!!!!
         WRITE (2,*) 'icetooce1 phisc(i,j)= ', phisc(52,2)
      do j=js1,js2
       do i=2,imax-1
C     Total heat flux. Units: ice(degree/timestep)
         sbcocn(i,j,3)=phiss(i,j,1)*dttofl
c     Freshwater flux (concentration/dilution effect)
C       Converts the salt flux from ice into a freshwater flux for ocean
c       (ie salt flux divided by SSS and unit conversion from 
c       psu/timestep to kg/m2/s)
         sbcocn(i,j,4)=phiss(i,j,2)*dstofl/(sbcocn(i,j,7)+zepsi)
c     Freshwater flux (volume flux for free surface)
c       Multiply by rho0 to obtain the right dimensions (Kg/m2/s)
         sbcocn(i,j,10)=phiss(i,j,0)*rho0/dts(ks2)
c     Calving 
c       Multiply by rho0 to obtain the right dimensions (Kg/m2/s)
         sbcocn(i,j,11)=phisc(i,j)*rho0/dts(ks2)
c     Short Wave flux. Units: ice(W/m**2)
         sbcocn(i,j,5)=fcm1(i,j)
c
C CAUTION definition of velocity point different for ocean and sea ice
         ip1=(i+1)+(2)*(imax/i)
         jp1=j+1
C     taux , tauy Units: ice(Nm-2/rho0), ocean dynes/cm2
          sbcocn(i,j,1)=-phisu(i,j)*rho0
          sbcocn(i,j,2)=-phisv(i,j)*rho0
c albedo
          IF ( icoupl .EQ. 1 ) THEN 
              ih=max0(0,isign(1,j-jeq))
              zmudum = 0.4
              call shine(ih,zmudum,tfsn,tfsg,ts(i,j),hgbq(i,j),
     .            hnbq(i,j),zalb,zalcn,zalbp,zaldum)
C zalbp  : ice albedo, clear sky
c zalb   : ice albedo for overcast sky
c zalcnp : ocean albedo, clear sky
c zalcn  : ocean albedo, overcast sky
c Ice albedo
              sbcocn(i,j,8) = 0.5*zalbp+0.5*zalb !albedo de Anne
c Ice temperature ??
              sbcocn(i,j,9) = ts (i,j)
          ENDIF 
C Sea ice cover
          sbcocn(i,j,6)=1.0-albq(i,j) ! Couverture de glace
C              
       enddo
      enddo

         WRITE (2,*) 'icetooce2 sbcocn(52,2,11) =', sbcocn(52,2,11)
      return
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c- end of routine icetooce
      end
