c $Header: /home/evian/ROOTCVS/ORCA/OPA/SRC_UCL/ocetoice.F,v 1.1.1.1 2001/06/05 11:56:55 valcke Exp $
      subroutine ocetoice(ciobc,sbcocn)
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c this routine transfers the information from the ocean to the ice
c-----
c  modif : 10/5/99
 
      include 'type.com'
      include 'const.com'
      include 'para.com'
      include 'bloc.com'
      include 'ice.com'
      include 'dynami.com'
#if defined key_coupled
#include "ocetoice.coupled.h"
#else
c--Local variables
      real sbcocn(imax,jmax,10)
      real ciobc (imax,jmax,7)
      km=1
c--transmit forcing
      do j=1,jmax
       do i=1,imax
C    air temperature (ice = degree kelvin)
         tabq(i,j)=ciobc(i,j,2)+273.15
c    humidity (fraction of 1)
         tdew(i,j)=ciobc(i,j,3)
c    wind speed (m/s)
         vabq(i,j)=ciobc(i,j,6)
c    cloud cover (fraction of 1)
         cloud(i,j)=ciobc(i,j,7)
c    precipitation (mm/day)
         fwat(i,j)=ciobc(i,j,1)
c    river runoff (m/s)
         runoff_lln(i,j)=0.0
         sdvt(i,j)=0.0
c    calving (mm/day)
         calving(i,j)=0.0
c
C CAUTION definition of velocity point different for ocean and sea ice
         im1=(i-1)+(imax-2)*(1/i)
         jm1=max(j-1,1)
C    taux (Nm-2), tauy (Nm-2) over ocean
          tairox(i,j)=ciobc(i,j,4)
          tairoy(i,j)=ciobc(i,j,5)
c    taux (Nm-2), tauy (Nm-2) over ice
          tenagx(i,j)=ciobc(i,j,4)
          tenagy(i,j)=ciobc(i,j,5)
       enddo
      enddo
      write(98,*) 'test forcing'
      i=50 ;  j=4
      write(98,*) 
     &       tairox(i,j),tairoy(i,j)
      write(98,*) sbcocn(i,j,6),sbcocn(i,j,7), sbcocn(i,j,8),
     &               sbcocn(i,j,9)
      write(98,*) sbcocn(i,j,6),sbcocn(i,j,7)
     &           ,sbcocn(i,j,8),sbcocn(i,j,9)
c--transmit variables
      do j=1,jmax
       do i=1,imax
c Sea surface temperature (ice=degree kelvin)
          scal(i,j,ks2,1)=sbcocn(i,j,6) 
c Sea surface salinity (ice =psu)
          scal(i,j,ks2,2)=sbcocn(i,j,7)
       enddo
      enddo
      do j=2,ju2
       do i=1,imax
         im1=i
         jm1=j
c ocean zonal velocity at surface (ice =m/s)
          u(i,j,ks2)=sbcocn(im1,jm1,8)
c ocean meridional velocity at surface (ice=m/s)
          v(i,j,ks2)=sbcocn(im1,jm1,9)
C See surface elavation (ice= m)
C         eta(i,j)= ????
       enddo
      enddo
      write(98,*) 'test velocity,temp,sal'
      i=50
      j=12
      write(98,*) u(i,j,ks2),v(i,j,ks2),scal(i,j,ks2,1),
     &            scal(i,j,ks2,2)
#endif
      return
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c- end of routine ocetoice
      end
