c $Header: /home/evian/ROOTCVS/ORCA/OPA/SRC_UCL/ocetoice.coupled.h,v 1.1.1.1 2001/06/05 11:56:55 valcke Exp $
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c this routine transfers the information from the ocean to the ice
c coupled case
c-----
c  modif : 10/5/99
 
c--Local variables
      real sbcocn(imax,jmax,10)
      real ciobc (imax,jmax,13)
      REAL zfp
C
      km=1
c--transmit forcing
      do j=1,jmax
       do i=1,imax
c le flux solaire (descendant+montant) sur l'ocean libre
         fsolcn ( i, j) = ciobc ( i, j,  1)
c le flux solaire (descendant+montant) sur la glace
         fsolg  ( i, j) = ciobc ( i, j,  2)
c le flux non solaire avec le flux IR montant sur l'ocean
         ratbqo ( i, j) = ciobc ( i, j,  3)
c le flux non solaire sauf le flux IR montant sur la glace
         ratbqg ( i, j) = ciobc ( i, j,  4)
c en W/m2
c le bilan hydrique ( precip totale - evap 
c                    SANS le runoff et le calving )
         fwat   ( i, j) = ciobc ( i, j,  5) 
c les precipitations neigeuses
         hnplbq ( i, j) = ciobc ( i, j,  6)
c le calving (utilise seulement pour bilan de chaleur ds les leads)
         calving ( i, j) = ciobc ( i, j,  13)
c en kg/(day*m2)
c la derivee des flux sens+lat+IR sur la glace
         fder   ( i, j) = ciobc ( i, j,  8)
c la tension de vent sur l'ocean suivant i
         tairox ( i, j) = ciobc ( i, j,  9)
c la tension de vent sur la glace suivant i
         tenagx ( i, j) = ciobc ( i, j, 10)
c la tension de vent sur l'ocean suivant j
         tairoy ( i, j) = ciobc ( i, j, 11)
c la tension de vent sur la glace suivant j
         tenagy ( i, j) = ciobc ( i, j, 12)
c river runoff
         runoff_lln ( i, j) = 0.0e0
         sdvt   ( i, j) = 0.0e0
C flux sensible
         fcscn  ( i, j) = 0.0e0
C flux latent
         flecn  ( i, j) = 0.0e0
C
       enddo
      enddo
      write(98,*) 'test forcing'
      i=53 ; j=4
      write(98,*) tabq(i,j),tdew(i,j),vabq(i,j)
     &       ,cloud(i,j),fwat(i,j),runoff_lln(i,j)
     &       ,tairox(i,j),tairoy(i,j)
      write(98,*) sbcocn(i,j,6),sbcocn(i,j,7), sbcocn(i,j,8),
     &               sbcocn(i,j,9)
      write(98,*) sbcocn(i,j,6),sbcocn(i,j,7)
     &           ,sbcocn(i,j,8),sbcocn(i,j,9)
c--transmit variables
      do j=1,jmax
       do i=1,imax
c Sea surface temperature (ice=degree kelvin)
          scal(i,j,ks2,1)=sbcocn(i,j,6) 
c Sea surface salinity (ice =psu)
          scal(i,j,ks2,2)=sbcocn(i,j,7)
       enddo
      END DO
C
c$$$C
c$$$C
      do j=2,ju2
       do i=1,imax
         im1=i
         jm1=j
c ocean zonal velocity at surface (ice =m/s)
          u(i,j,ks2)=sbcocn(im1,jm1,8)
c ocean meridional velocity at surface (ice=m/s)
          v(i,j,ks2)=sbcocn(im1,jm1,9)
C See surface elavation (ice= m)
C         eta(i,j)= ????
       enddo
      enddo
      write(98,*) 'test velocity,temp,sal'
      i=50
      j=13
      write(98,*) u(i,j,ks2),v(i,j,ks2),scal(i,j,ks2,1),
     &            scal(i,j,ks2,2)
C
c$$$      WRITE (2,*) 'SST dans ocetoice (Celcius)'
c$$$      CALL prihre(scal(:,:,ks2,1)-273.15,
c$$$     $    imax,jmax,1,imax,1,1,jmax,1,1.0,2)
c$$$      WRITE (2,*) 'SSS dans ocetoice'
c$$$      CALL prihre(scal(:,:,ks2,2),
c$$$     $    imax,jmax,1,imax,1,1,jmax,1,1.0,2)
c$$$      zfp = 0.1 ; WRITE (2,*) 'fsolcn dans ocetoice ', zfp
c$$$      CALL prihre( fsolcn,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 0.1 ; WRITE (2,*) 'fsolg  dans ocetoice ', zfp
c$$$      CALL prihre( fsolg ,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 0.1 ; WRITE (2,*) 'fsolcn dans ocetoice ', zfp
c$$$      CALL prihre( fsolcn,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 0.1 ; WRITE (2,*) 'ratbqo dans ocetoice ', zfp
c$$$      CALL prihre( ratbqo,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 0.1 ; WRITE (2,*) 'ratbqg dans ocetoice ', zfp
c$$$      CALL prihre( ratbqg,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 0.0 ; WRITE (2,*) 'fwat   dans ocetoice ', zfp
c$$$      CALL prihre( fwat  ,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 0.0 ; WRITE (2,*) 'hnplbq dans ocetoice ', zfp
c$$$      CALL prihre( hnplbq,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 0.1 ; WRITE (2,*) 'fder   dans ocetoice ', zfp
c$$$      CALL prihre( fder  ,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 10.0 ; WRITE (2,*) 'tairox dans ocetoice ', zfp
c$$$      CALL prihre( tairox,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 10.0 ; WRITE (2,*) 'tenagx dans ocetoice ', zfp
c$$$      CALL prihre( tenagx,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 10.0 ; WRITE (2,*) 'tairox dans ocetoice ', zfp
c$$$      CALL prihre( tairox,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 10.0 ; WRITE (2,*) 'tenagy dans ocetoice ', zfp
c$$$      CALL prihre( tenagy,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 0.0 ; WRITE (2,*) 'runoff dans ocetoice ', zfp
c$$$      CALL prihre( runoff_lln,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 0.0 ; WRITE (2,*) 'sdvt dans ocetoice ', zfp
c$$$      CALL prihre( sdvt  ,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 0.0 ; WRITE (2,*) 'u dans ocetoice ', zfp
c$$$      CALL prihre( u     ,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
c$$$      zfp = 0.0 ; WRITE (2,*) 'v dans ocetoice ', zfp
c$$$      CALL prihre( v     ,imax,jmax,1,imax,1,1,jmax,1,zfp,2)
C
